darcs-2.12.5: a distributed, interactive, smart revision control system

Safe Haskell | None
Language | Haskell2010

Darcs.UI.ApplyPatches

Synopsis

- class PatchApplier pa where
  - type ApplierRepoTypeConstraint pa (rt :: RepoType) :: Constraint
- data PatchProxy p = PatchProxy
- data StandardPatchApplier = StandardPatchApplier

# Documentation

class PatchApplier pa where #

This class is a hack to abstract over pullapply and rebase pullapply.

Minimal complete definition

repoJob, applyPatches

Associated Types

type ApplierRepoTypeConstraint pa (rt :: RepoType) :: Constraint #

Methods

repoJob :: pa -> [DarcsFlag] -> (forall rt p wR wU. (IsRepoType rt, ApplierRepoTypeConstraint pa rt, RepoPatch p, ApplyState p ~ Tree, ApplyState (PrimOf p) ~ Tree) => PatchProxy p -> Repository rt p wR wU wR -> IO ()) -> RepoJob () #

applyPatches :: forall rt p wR wU wT wX wZ. (ApplierRepoTypeConstraint pa rt, IsRepoType rt, RepoPatch p, ApplyState (PrimOf p) ~ Tree, ApplyState p ~ Tree) => pa -> PatchProxy p -> String -> [DarcsFlag] -> String -> Repository rt p wR wU wT -> FL (PatchInfoAnd rt p) wX wT -> FL (PatchInfoAnd rt p) wX wZ -> IO () #

Instances

PatchApplier StandardPatchApplier # |
Associated Types type ApplierRepoTypeConstraint StandardPatchApplier (rt :: RepoType) :: Constraint # Methods repoJob :: StandardPatchApplier -> [DarcsFlag] -> (forall rt p wR wU. (IsRepoType rt, ApplierRepoTypeConstraint StandardPatchApplier rt, RepoPatch p, (((* -> *) -> *) ~ ApplyState p) Tree, (((* -> *) -> *) ~ ApplyState (PrimOf p)) Tree) => PatchProxy p -> Repository rt p wR wU wR -> IO ()) -> RepoJob () # applyPatches :: (ApplierRepoTypeConstraint StandardPatchApplier rt, IsRepoType rt, RepoPatch p, (((* -> *) -> *) ~ ApplyState (PrimOf p)) Tree, (((* -> *) -> *) ~ ApplyState p) Tree) => StandardPatchApplier -> PatchProxy p -> String -> [DarcsFlag] -> String -> Repository rt p wR wU wT -> FL (PatchInfoAnd rt p) wX wT -> FL (PatchInfoAnd rt p) wX wZ -> IO () #

data PatchProxy p #

Constructors

PatchProxy |

data StandardPatchApplier #

Constructors

StandardPatchApplier |

Instances

PatchApplier StandardPatchApplier # |
Associated Types type ApplierRepoTypeConstraint StandardPatchApplier (rt :: RepoType) :: Constraint # Methods repoJob :: StandardPatchApplier -> [DarcsFlag] -> (forall rt p wR wU. (IsRepoType rt, ApplierRepoTypeConstraint StandardPatchApplier rt, RepoPatch p, (((* -> *) -> *) ~ ApplyState p) Tree, (((* -> *) -> *) ~ ApplyState (PrimOf p)) Tree) => PatchProxy p -> Repository rt p wR wU wR -> IO ()) -> RepoJob () # applyPatches :: (ApplierRepoTypeConstraint StandardPatchApplier rt, IsRepoType rt, RepoPatch p, (((* -> *) -> *) ~ ApplyState (PrimOf p)) Tree, (((* -> *) -> *) ~ ApplyState p) Tree) => StandardPatchApplier -> PatchProxy p -> String -> [DarcsFlag] -> String -> Repository rt p wR wU wT -> FL (PatchInfoAnd rt p) wX wT -> FL (PatchInfoAnd rt p) wX wZ -> IO () #
type ApplierRepoTypeConstraint StandardPatchApplier rt # |
type ApplierRepoTypeConstraint StandardPatchApplier rt = ()